import _objectSpread from "@babel/runtime/helpers/objectSpread";
import { observe } from 'mobx';
import { propertyDecorator } from 'decorating';
import { attachInitializer } from '../utils';
export default propertyDecorator(function (target, prop, desc, handler, invokeImmediately) {
  if (!handler) throw new Error("@observe must be called with handler argument");
  attachInitializer(target, prop, function (store) {
    observe(store, prop, handler.bind(store), invokeImmediately);
  });
  return desc && _objectSpread({}, desc, {
    configurable: true
  });
});